=== debian/changelog ===
freeorion (0.4.5-1build1) xenial; urgency=medium

  * No-change rebuild against libglew1.13

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 11 Nov 2015 17:45:02 +0000

freeorion (0.4.5-1) unstable; urgency=medium

  * New upstream release.

 -- Markus Koschany <apo@gambaru.de>  Tue, 08 Sep 2015 15:28:33 +0200

freeorion (0.4.5~RC1-1) unstable; urgency=medium

  * New upstream release candidate.
  * Stop building on architectures which regularly fail to build FreeOrion.
    This includes mips and mipsel. Apparently their auto-builders cannot provide
    enough memory which causes frequent FTBFS and there is no indication that
    the situation will improve in the near future.
  * debian/rules: Remove mips, mipsel and sparc from WEAK_HOSTS.
  * Update get-orig-source target.

 -- Markus Koschany <apo@gambaru.de>  Mon, 24 Aug 2015 23:39:16 +0200
