=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/freeorion-$1.tar.gz/" \
https://github.com/freeorion/freeorion/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
